#include <windows.h>

#include <stdio.h>

#include "blowfish.h"
#include "bf_util.h"

BOOL WINAPI
__declspec(dllexport)
LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
	return TRUE;
}

BOOL WINAPI
__declspec(dllexport) WINAPI
hsp_blowfish_init(void *key, int len, int p3, int p4)
{
	if (!len)
		return -1;

	/*
	  XXX
	*/
	return -(int)InitializeBlowfish(key, len);
}

BOOL WINAPI
__declspec(dllexport) WINAPI
hsp_blowfish_clean(int ctx, int p2, int p3, int p4)
{
	FinishBlowfish((bf_ctx_t *)ctx);
	return 0;
}

BOOL WINAPI
__declspec(dllexport) WINAPI
hsp_blowfish_encrypt(void *dest, int len, int ctx, int p4)
{
	unsigned char *tmp;
	unsigned char *d, *s;
	int i;

	if (!len)
		return -1;

	if ((tmp = (unsigned char *)malloc(len)) == NULL)
		return -1;

	s = dest;
	d = tmp;
	for (i = 0; i < len; i++) {
		*s++ = *d++;
	}

	if (!Blowfish_encipher_data((bf_ctx_t *)ctx, dest, tmp, len))
		return -1;

#ifdef PARANOIA
	/* cleaning for security, meaningless? */
	d = tmp;
	for (i = 0; i < len; i++)
		*d++ = 0;
#endif

	free(tmp);

	return 0;
}

BOOL WINAPI
__declspec(dllexport) WINAPI
hsp_blowfish_decrypt(void *dest, int len, int ctx, int p4)
{
	unsigned char *tmp;
	unsigned char *d, *s;
	int i;

	if (!len)
		return -1;

	if ((tmp = (unsigned char *)malloc(len)) == NULL)
		return -1;

	s = dest;
	d = tmp;
	for (i = 0; i < len; i++) {
		*s++ = *d++;
	}

	if (!Blowfish_decipher_data((bf_ctx_t *)ctx, dest, tmp, len))
		return -1;

#ifdef PARANOIA
	/* cleaning for security, meaningless? */
	d = tmp;
	for (i = 0; i < len; i++)
		*d++ = 0;
#endif

	free(tmp);

	return 0;
}

